SystemOrganization addCategory: #'Sight-TestBed'!

TestResult subclass: #STestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-TestBed'!

!STestResult class methodsFor: 'instance creation' stamp: 'bs 7/21/2010 16:12:44.558'!
withFailedTest: aTestMethod
	^ self new
		addToFailures: aTestMethod newTestCase;
		yourself! !

!STestResult class methodsFor: 'instance creation' stamp: 'bs 7/23/2010 10:02:19.529'!
withFailedTests: testMethods
	| aTestResult |
	aTestResult := self new.
	testMethods do: [:ea | aTestResult addToFailures: ea newTestCase].
	^ aTestResult! !

!STestResult class methodsFor: 'instance creation' stamp: 'bs 7/21/2010 16:10:08.134'!
withPassedTest: aTestMethod
	^ self new
		addToPassed: aTestMethod newTestCase;
		yourself! !

!STestResult class methodsFor: 'instance creation' stamp: 'bs 8/6/2010 15:36:38.563'!
withPassedTest: passedTestMethod withFailedTest: failedTestMethod
	^ self withPassedTests: {passedTestMethod} withFailedTests: {failedTestMethod}! !

!STestResult class methodsFor: 'instance creation' stamp: 'bs 7/23/2010 10:04:37.696'!
withPassedTests: testMethods
	| aTestResult |
	aTestResult := self new.
	testMethods do: [:ea | aTestResult addToPassed: ea newTestCase].
	^ aTestResult! !

!STestResult class methodsFor: 'instance creation' stamp: 'bs 8/6/2010 15:36:06.104'!
withPassedTests: passedTestMethods withFailedTests: failedTestMethods
	| result |
	result := self new.
	passedTestMethods do: [:ea | result addToPassed: ea newTestCase].
	failedTestMethods do: [:ea | result addToFailures: ea newTestCase].
	^ result! !

!STestResult methodsFor: 'as yet unclassified' stamp: 'bs 7/21/2010 16:12:34.447'!
addToFailures: aTestCase
	failures add: aTestCase! !

!STestResult methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:22:31.615'!
addToPassed: aTestCase
	passed add: aTestCase! !

!STestResult methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 17:20:39.51'!
passedTestMethods
	^ self passed asIdentitySet collect: [:ea | ea selectedMethod]! !

!STestResult methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 17:35:11.698'!
testMethods
	^ self tests asIdentitySet collect: [:ea | ea selectedMethod]! !

TestCase subclass: #STbPersonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-TestBed'!

!STbPersonTest class methodsFor: 'as yet unclassified' stamp: 'bs 7/3/2010 10:41:32.7'!
wantsRecompilationProgressReported
	^ false! !

!STbPersonTest methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:34.626'!
testCompleteName
	| paul |
	paul := STbPerson new.
	paul firstname: 'Paul'.
	self assert: 'Paul' equals: paul completeName.
	self assert: 'a STbPerson' equals: paul asString.! !

!STbPersonTest methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 16:01'!
testFailing
	self assert: false.
	! !

!STbPersonTest methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:55:10.278'!
testFirstnameAccessors
	| paul |
	paul := STbPerson new.
	paul firstname: 'Paul'.
	self assert: 'Paul' equals: paul firstname.
	self assert: 'a STbPerson' equals: paul asString.! !

!STbPersonTest methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:34.228'!
testFirstnameAccessors2
	| paul |
	paul := STbPerson new.
	paul firstname: 'Paul'.
	self assert: 'Paul' equals: paul firstname.
	self assert: 'a STbPerson' equals: paul asString.! !

TestCase subclass: #STbTestCase
	instanceVariableNames: 'exampleMethodSource exampleTestMethodSource createdClasses installedMethods removedMethods undoInTearDown createdWrappers ensureBlocks addedInstVars addedClassVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-TestBed'!

!STbTestCase class methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 08:31:21.685'!
personClass
	^ STbPerson! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 22:30:39.182'!
addClassVar: aName to: aClass
	aClass addClassVarName: aName.
	(self addedClassVars 
		at: aClass name
		ifAbsentPut: Set new)
			add: aName.! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 22:30:51.581'!
addInstVar: aName to: aClass
	aClass addInstVarName: aName.
	(self addedInstVars 
		at: aClass name
		ifAbsentPut: Set new)
			add: aName.! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 8/17/2010 22:31:02.66'!
addedClassVars
	^ addedClassVars ifNil: [addedClassVars := Dictionary new]! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 8/17/2010 22:31:11.441'!
addedInstVars
	^ addedInstVars ifNil: [addedInstVars := Dictionary new]! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 8/9/2010 22:50:10.245'!
compileExampleMethod
	STbPerson compile: self exampleMethodSource! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/12/2010 20:27:50.484'!
compileExampleTestMethod
	STbPersonTest compile: self exampleTestMethodSource. ! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 8/23/2010 16:09:51.686'!
completeNameTestMethod
	^ STbPersonTest >> #testCompleteName! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:30:00.588'!
createExamplePersonSubclass
	| aClass |
	aClass := STbPerson subclass: #STbPersonSubclass
							instanceVariableNames: ''
							classVariableNames: ''
							poolDictionaries: ''
							category: self tbCategory.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass! !

!STbTestCase methodsFor: 'wrapping' stamp: 'bs 7/12/2010 15:31:39.439'!
createWrapper: aWrapperClass on: aSelector inClass: aClass
	| result |
	result := aWrapperClass on: aSelector inClass: aClass.
	self createdWrappers add: result.
	^ result! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:32:43.81'!
createdClasses
	^ createdClasses ifNil: [createdClasses := OrderedCollection new]! !

!STbTestCase methodsFor: 'wrapping' stamp: 'bs 7/6/2010 14:06:28.353'!
createdWrappers
	^ createdWrappers ifNil: [createdWrappers := OrderedCollection new]! !

!STbTestCase methodsFor: 'running' stamp: 'bs 7/29/2010 10:08:15.371'!
ensureBlocks
	^ ensureBlocks ifNil: [ensureBlocks := OrderedCollection new]! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2010 21:20:54.212'!
ensureCollection: oneOrManyMethods
	^ oneOrManyMethods isCompiledMethod 
		ifTrue: [{oneOrManyMethods}]
		ifFalse: [oneOrManyMethods]! !

!STbTestCase methodsFor: 'running' stamp: 'bs 8/19/2010 14:15:58.516'!
ensureInTearDown: aBlock
	self ensureBlocks add: aBlock! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/12/2010 20:22:15.944'!
exampleClass
	^ STbPerson! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/8/2010 16:46:00.936'!
exampleInstVarName
	^ 'firstname'! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/21/2010 21:26:41.287'!
exampleMethod
	^ self tbFirstnameSetter! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 19:31:27.957'!
exampleMethodSource
	^ exampleMethodSource! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 19:31:27.964'!
exampleMethodSource: anObject
	exampleMethodSource := anObject! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/12/2010 20:27:12.897'!
exampleSubclass
	^ STbEmployee! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/23/2010 14:42:45.971'!
exampleTestMethod
	^ self tbTestMethod! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 19:31:27.98'!
exampleTestMethodSource
	^ exampleTestMethodSource! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 19:31:27.987'!
exampleTestMethodSource: anObject
	exampleTestMethodSource := anObject! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/12/2010 20:27:50.479'!
exampleTestSuite
	^ STbPersonTest suite! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2010 16:29:57.45'!
installMethod: aMethod
	aMethod methodClass 
		addSelector: aMethod selector
		withMethod: aMethod.! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:31:28.372'!
installMethod: source inClass: aClass
	|selector|
	selector := aClass compile: source.
	self undoInTearDown ifTrue: [
		self installedMethods add: {aClass. selector}].
	^ selector! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:33:03.941'!
installedMethods
	^ installedMethods ifNil: [installedMethods := OrderedCollection new]! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 8/23/2010 21:16:02.781'!
recompile: aMethod
	aMethod methodClass compile: aMethod getSource. 
	^ aMethod methodClass >> aMethod selector! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:31:28.418'!
reinstallRemovedMethods
	|aClass selector sourceCode |
	self removedMethods do: [ :classSelectorSourceCodeTuple | 
		aClass := classSelectorSourceCodeTuple first.
		selector := classSelectorSourceCodeTuple second.
		sourceCode := classSelectorSourceCodeTuple third.
		(aClass includesSelector: selector)
			ifFalse: [ aClass compile: sourceCode ] ]! !

!STbTestCase methodsFor: 'running' stamp: 'bs 8/17/2010 22:35:52.992'!
removeAddedInstAndClassVars
	self addedClassVars keysAndValuesDo: [:className :classVars |
		classVars do: [:ea | (Smalltalk at: className) removeClassVarName: ea ]].
	self addedInstVars keysAndValuesDo: [:className :instVars |
		instVars do: [:ea | (Smalltalk at: className) removeInstVarName: ea ]].
	{self addedInstVars. self addedClassVars} do: [:ea | ea removeAll].! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:31:28.426'!
removeCreatedClasses
	self createdClasses copy do: [ :aClass | 
		aClass removeFromSystem.
		(Smalltalk classNamed: aClass name) 
			ifNotNil: [aClass removeFromSystem].
		self createdClasses remove: aClass. ]! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:31:28.435'!
removeInstalledMethods
	| aClass selector |
	self installedMethods do: [:classSelectorTuple |
		aClass := classSelectorTuple first.
		selector := classSelectorTuple second.
		(aClass includesSelector: selector) 
			ifTrue: [ aClass removeSelector: selector ] ]! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:31:28.443'!
removeMethod: aCompiledMethod
	|selector sourceCode aClass|
	aClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.
	sourceCode := aClass sourceCodeAt: selector.
	self removedMethods add: {aClass. selector. sourceCode}.
	aClass removeSelector: selector. ! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2010 17:40:46.613'!
removeMethods: compiledMethods
	compiledMethods do: [:ea | self removeMethod: ea]! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:34:12.987'!
removedMethods
	^ removedMethods ifNil: [removedMethods := OrderedCollection new]! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2010 19:25:55.031'!
resetTbExampleMethods
	(self exampleMethod getSource = self exampleMethodSource)
		ifFalse: [self compileExampleMethod].
	(self exampleTestMethod getSource = self exampleTestMethodSource)
		ifFalse: [self compileExampleTestMethod].! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:45:49.725'!
runTbTests
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTests: (self tbTestMethods collect: [:ea | ea newTestCase]).
	TestRunner new runSuite: aSuite.! !

!STbTestCase methodsFor: 'running' stamp: 'bs 7/4/2010 19:35:10.893'!
setUp
	super setUp.
	self exampleMethodSource: self exampleMethod getSource.
	self exampleTestMethodSource: self exampleTestMethod getSource.
! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/12/2010 19:52:48.427'!
tbCategory
	^ SystemOrganization categoryOfElement: self exampleClass name.! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 8/9/2010 23:06:01.239'!
tbClasses
	^ (self tbPackage classes gather: [ :ea | { ea. ea class }]) asIdentitySet! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/23/2010 15:25:04.063'!
tbExampleMethod
	^ self tbFirstnameSetter! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/23/2010 15:25:09.345'!
tbExampleMethod2
	^ self tbFirstnameGetter! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/21/2010 21:26:15.963'!
tbFirstnameGetter
	^ (STbPerson >> #firstname)! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/21/2010 21:26:34.668'!
tbFirstnameSetter
	^ (STbPerson >> #firstname:)! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/21/2010 16:44:39.687'!
tbMethods
	^ self tbClasses flatCollect: [ :c | c methodDict values ]! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 3/3/2011 13:29:08.935'!
tbNumberOfExpectedPasses
	^ self tbTestMethods size - 1! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/12/2010 20:26:07.798'!
tbPackage
	^ PackageInfo named: self tbCategory.! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/23/2010 14:42:38.34'!
tbTestMethod
	^ STbPersonTest >> #testFirstnameAccessors! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/23/2010 14:42:13.527'!
tbTestMethod2
	^ STbPersonTest >> #testFirstnameAccessors2! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 8/10/2010 18:33:22.853'!
tbTestMethods
	^ (self tbClasses select: [:ea | ea isTestCaseClass]) flatCollect: [:c | c testMethods]! !

!STbTestCase methodsFor: 'running' stamp: 'bs 8/23/2010 22:02:33.35'!
tearDown
	self ensureBlocks do: [:ea | ea value].
	self
		uninstallCreatedWrappers;
		removeCreatedClasses;
		reinstallRemovedMethods;
		removeInstalledMethods;
		resetTbExampleMethods.
	super tearDown.! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 19:35:43.983'!
undoInTearDown
	^ undoInTearDown ifNil: [undoInTearDown := false]! !

!STbTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 19:31:28.031'!
undoInTearDown: anObject
	undoInTearDown := anObject! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:31:28.489'!
undoInTearDownDo: aBlock
	self undoInTearDown: true.
	aBlock value.
	self undoInTearDown: false.! !

!STbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/6/2010 14:07:11.575'!
uninstallCreatedWrappers
	self createdWrappers do: [ :wrapper | wrapper uninstall ].! !

!STbTestCase methodsFor: 'wrapping' stamp: 'bs 7/6/2010 14:55:58.744'!
wrap: aMethod using: aWrapperClass
	^ self wrapOn: aMethod selector inClass: aMethod methodClass using: aWrapperClass! !

!STbTestCase methodsFor: 'wrapping' stamp: 'bs 7/6/2010 14:55:26.548'!
wrapOn: selector inClass: aClass using: aWrapperClass
	| wrapper |
	wrapper := self 
		createWrapper: aWrapperClass 
		on: selector 
		inClass: aClass.
	wrapper install.
	^ wrapper! !

Object subclass: #STbPerson
	instanceVariableNames: 'firstname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-TestBed'!

STbPerson subclass: #STbEmployee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-TestBed'!

!STbEmployee methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 09:12:45.428'!
instVarAccessMethod
	^ firstname! !

!STbEmployee methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 09:12:58.944'!
nonInstVarAccessMethod
	^ 'Hello World'! !

!STbPerson class methodsFor: 'as yet unclassified' stamp: 'bs 10/28/2009 09:24'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!STbPerson methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:54:58.564'!
asString
	^ super asString! !

!STbPerson methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:38:23.132'!
completeName
	^ self firstname! !

!STbPerson methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:55:13.602'!
firstname
	^ firstname ! !

!STbPerson methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:55:10.516'!
firstname: anObject
	firstname := anObject! !
